// Import your models and any needed services here
import { fetchCountries,getCountry, fetchCurrencies, getInternationalTransaction
    // fetchCountryByID,
    // addCountry,
    // updateCountry
 } from "../services/country.service.js";


export const listCountries = async (req, res, next) => {
    try {
        // Extract headers from the request
        const { authorization, username } = req.headers;
        const countries = await fetchCountries(authorization, username);
        res.json(countries);
    } catch (err) {
        next(err);
    }
};


export const handleGetCountry = async (req, res, next) => {
  try {
      // Make sure to match the case sensitivity of the route parameter defined in your route
      const { countryId } = req.params; // changed from countryID to countryId
      const authorizationToken = req.headers.authorization; // Or 'authorization' if you are sending it in lowercase
      const username = req.headers.username; // Or 'username' if you are sending it in lowercase

      const countryData = await getCountry(countryId, authorizationToken, username);
      res.json(countryData);
  } catch (err) {
      next(err);
  }
};

export const listCurrencies = async (req, res, next) => {
  try {
    // Extract headers from the request
    const { authorization, username } = req.headers;
    const countries = await fetchCurrencies(authorization, username);
    res.json(countries);
  } catch (err) {
    next(err);
  }
  };


  export const getIntTransactionTypeList = async (req, res, next) => {
    try {
      // Extract headers from the request
      const { authorization, username } = req.headers;
      const countries = await getInternationalTransaction(authorization, username);
      res.json(countries);
    } catch (err) {
      next(err);
    }
    };
  
  // Continue to define the rest of the controller functions similarly
  // ...
  
  export const insertCountry = async (req, res, next) => {
    try {
      // Logic to insert a country
    } catch (err) {
      next(err);
    }
  };
  
  // ...
  