import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class BeneficiaryRegistrationService {
  constructor(private http: HttpClient) {}

  customerDetails(CustomerNo: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/customer-detail?CustomerNo=${CustomerNo}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCurrency(CountryCode: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/payout-currency-list?CountryCode=${CountryCode}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPhoneCode() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/phone-country-code-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPurposeOfTransfer() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/purpose-transfer-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getIdType() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/id-type-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSourceOfFund() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/source-of-found-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAccountTypeList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/account-type-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getRelationship() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/customer-relation-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  bankDetails(CountryCode: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/bank-detail?CountryCode=${CountryCode}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addBeneficiaryRegistration(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/beneficiary-registration`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
