import { Component, TemplateRef, ViewChild } from '@angular/core';
import { BeneficiaryRegistrationService } from '../beneficiary-registration.service';
import { getCacheData } from '../utils/helper';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';
import { EditBeneficiaryRegistrationService } from '../edit-beneficiary-registration.service';
import { ToastrService } from 'ngx-toastr';

@Component({
  selector: 'app-beneficiary-registration',
  templateUrl: './beneficiary-registration.component.html',
  styleUrls: ['./beneficiary-registration.component.css'],
})
export class BeneficiaryRegistrationComponent {
  @ViewChild('viewBankDetail') viewBankDetailModal;
  bsViewBankDetailModalRef: BsModalRef;

  PurposeOfTransfer: any = [];
  Currency: any = [];
  IdTypeList: any = [];
  SourceOfFund: any = [];
  AccountTypeList: any = [];
  Relationship: any = [];
  PhoneCode: any;
  CustomerNo: any;
  bankDetail: any = {};
  customerDetail: any = {};
  beneFirstName: any = '';
  beneLastName: any = '';
  beneMiddleName: any = '';
  beneNickName: any = '';
  beneAddress: any = '';
  dob: any = '';
  isoCode: string | null = null;
  telephone: any = '';
  selectedNationality: any;
  idNumber: any = '';
  selectedIdType: any = '0';
  selectedPaymentMode: any = 0;
  bankName: any = '';
  bankBranch: any = '';
  bankCode: any = '';
  branchCode: any = '';
  bankAccountNo: any = '';
  bankAddress: any = '';
  selectedPayoutCurrency: any = '0';
  purposeText: any = '';
  selectedPurposeofTransfer: any = '0';
  selectedCustomerRelation: any = '0';
  beneCity: any = '';
  selectedBeneCountryCode: any = '0';
  selectedBeneCountryCodePhone: any = '0';
  beneCountryText: any = '';
  selectedBeneSourceofFunds: any = '0';
  selectedBeneAccountType: any = '0';
  beneFatherSpouce: any = '';
  beneZipCode: any = '';
  beneCountryCode: any = [
    { id: 'IND', name: 'INDIA' },
    { id: 'PAK', name: 'PAKISTAN' },
    { id: 'LKA', name: 'SRI LANKA' },
  ];
  declaration: any = false;
  bankDetails: any = [];
  bankDetailName: any = '';
  branchName: any = '';
  isFormValid: boolean = false;

  constructor(
    private BeneficiaryRegistrationSvc: BeneficiaryRegistrationService,
    private EditBeneficiaryRegistrationSvc: EditBeneficiaryRegistrationService,
    private modalService: BsModalService,
    private toastrSvc: ToastrService
  ) { }

  ngOnInit(): void {
    this.getPhoneCode();
    this.getPurposeOfTransfer();
    this.getIdTypeList();
    this.getSourceOfFund();
    this.getRelationship();
    this.getAccountTypeList();
  }

  onSelectCountryCode(CountryCode) {
    this.getCurrency(CountryCode);
    // this.bankDetails(CountryCode);
  }

  // bankDetails(CountryCode: any) {
  //   this.BeneficiaryRegistrationSvc.bankDetails(CountryCode).subscribe(
  //     (res) => {
  //       this.bankDetail = res[0];
  //     },
  //     (error) => this.handleError(error)
  //   );
  // }

  customerDetails() {
    if (this.CustomerNo) {
      this.BeneficiaryRegistrationSvc.customerDetails(
        this.CustomerNo
      ).subscribe(
        (res) => {
          this.customerDetail = res[0];
        },
        (error) => this.handleError(error)
      );
    } else {
      alert('Please Enter Customer Number');
    }
  }

  getCurrency(CountryCode: string) {
    this.BeneficiaryRegistrationSvc.getCurrency(CountryCode).subscribe(
      (res) => {
        this.Currency = res;
      },
      (error) => this.handleError(error)
    );
  }

  getPhoneCode() {
    this.BeneficiaryRegistrationSvc.getPhoneCode().subscribe(
      (res) => {
        this.PhoneCode = res;
      },
      (error) => this.handleError(error)
    );
  }

  getPurposeOfTransfer() {
    this.BeneficiaryRegistrationSvc.getPurposeOfTransfer().subscribe(
      (res) => {
        this.PurposeOfTransfer = res;
      },
      (error) => this.handleError(error)
    );
  }

  getIdTypeList() {
    this.BeneficiaryRegistrationSvc.getIdType().subscribe(
      (res) => {
        this.IdTypeList = res;
      },
      (error) => this.handleError(error)
    );
  }

  getSourceOfFund() {
    this.BeneficiaryRegistrationSvc.getSourceOfFund().subscribe(
      (res) => {
        this.SourceOfFund = res;
      },
      (error) => this.handleError(error)
    );
  }

  getAccountTypeList() {
    this.BeneficiaryRegistrationSvc.getAccountTypeList().subscribe(
      (res) => {
        this.AccountTypeList = res;
      },
      (error) => this.handleError(error)
    );
  }

  getRelationship() {
    this.BeneficiaryRegistrationSvc.getRelationship().subscribe(
      (res) => {
        this.Relationship = res;
      },
      (error) => this.handleError(error)
    );
  }

  addBeneficiaryRegistration() {
    if (this.selectedBeneCountryCode == '0' || !this.selectedBeneCountryCode) {
      alert('Please Select Payout Country Code.');
      return;
    }

    if (this.selectedPaymentMode == '0' || !this.selectedPaymentMode) {
      alert('Please Select Payment Mode.');
      return;
    }

    if (this.selectedPayoutCurrency == '0' || !this.selectedPayoutCurrency) {
      alert('Please Select Payout Currency.');
      return;
    }

    if (
      this.selectedPurposeofTransfer == '0' ||
      !this.selectedPurposeofTransfer
    ) {
      alert('Please Select Purpose of Transfer.');
      return;
    }

    if (!this.beneFirstName) {
      alert('Please Fill Beneficiary First Name');
      return;
    }
    if (!this.beneLastName) {
      alert('Please Fill Beneficiary Last Name');
      return;
    }
    if (!this.beneNickName) {
      alert('Please Fill Beneficiary Nick Name');
      return;
    }

    if (this.selectedPaymentMode == '1') {
      if (!this.bankDetail.BankName) {
        alert('Please Fill Bank Name');
        return;
      }
      if (!this.bankAccountNo) {
        alert('Please Fill Bank Account Number');
        return;
      }
      if (!this.bankDetail.bankBranchName) {
        alert('Please Fill Bank Branch Name');
        return;
      }
      if (!this.bankDetail.bankcode) {
        alert('Please Fill Branch');
        return;
      }

      if (!this.branchCode) {
        alert('Please Fill Branch Code');
        return;
      }
      if (!this.bankDetail.bankBranch) {
        alert('Please Fill Bank Branch Address');
        return;
      }
      if (!this.bankCode) {
        alert('Please Fill Bank/IFSC Code');
        return;
      }
    } else {
      if (!this.bankDetail.bankBranchName) {
        alert('Please Fill Bank Branch Name');
        return;
      }
      if (!this.branchCode) {
        alert('Please Fill Branch Code');
        return;
      }
      if (!this.bankDetail.bankBranch) {
        alert('Please Fill Bank Branch Address');
        return;
      }
    }

    this.purposeText = this.PurposeOfTransfer.find(
      (p) => p.PurposeOfTransferID == this.selectedPurposeofTransfer
    )?.PurposeOfTranfer;
    this.beneCountryText = this.beneCountryCode.find(
      (c) => c.id == this.selectedBeneCountryCode
    )?.name;

    let payload = {
      BeneficiaryNo: '',
      CustomerNo: this.CustomerNo,
      FirstName: this.beneFirstName,
      MiddleName: this.beneMiddleName,
      LastName: this.beneLastName,
      NickName: this.beneNickName,
      BeneficiaryAddress: this.beneAddress,
      DOB: this.dob,
      Telephone: this.telephone,
      Nationality: this.customerDetail.Nationality,
      Idnumber: this.idNumber,
      IdType: Number(this.selectedIdType),
      PaymentMode: this.selectedPaymentMode == '1' ? 'Bank' : 'Cash',
      BankName: this.selectedPaymentMode == '1' ? this.bankDetail.BankName : '',
      DestinationCountry: this.selectedBeneCountryCode,
      BankBranch: this.bankDetail.bankBranchName,
      BankCode: this.bankDetail.bankcode,
      BankAccountNo: this.selectedPaymentMode == '1' ? this.bankAccountNo : '',
      BankAddress:
        this.selectedPaymentMode == '1' ? this.bankDetail.bankBranch : '',
      BranchCode: this.branchCode,
      BranchAddress: this.bankDetail.bankBranch,
      PayoutCurrency: this.selectedPayoutCurrency,
      PurposeText: '',
      Purpose: this.selectedPurposeofTransfer,
      UserID: getCacheData('G_UserID'),
      CustomerRelation: Number(this.selectedCustomerRelation),
      BeneficiaryCity: this.beneCity,
      beneficiaryPhoneCountryCodeValue: Number(
        this.selectedBeneCountryCodePhone
      ),
      beneficiaryPhoneCountryCodeText: this.isoCode ? this.isoCode : '0',
      BeneficiarySourceoffunds: this.selectedBeneSourceofFunds
        ? this.selectedBeneSourceofFunds
        : '0',
      BeneficiaryAccountType: this.selectedBeneAccountType
        ? this.selectedBeneAccountType
        : '0',
      BeneficiaryZipCode: this.beneZipCode,
      Declaration: this.declaration,
      FatherSpouse: this.beneFatherSpouce,
    };

    this.BeneficiaryRegistrationSvc.addBeneficiaryRegistration(
      payload
    ).subscribe({
      next: (res: any) => {
        // Handle success response if needed
        if (res) {
          // alert(`Beneficiary ${res} register successfully.`);
          this.toastrSvc.success(`Beneficiary ${res} register successfully.`);
          return;
        }
      },
      error: (error) => this.handleError(error), // Error handling
      complete: () => {
        this.clearFields();
      },
    });
  }

  clearFields(): void {
    this.customerDetail = {};
    this.branchCode = '';
    this.bankDetail = {};
    this.CustomerNo = '';
    this.beneFirstName = '';
    this.beneMiddleName = '';
    this.beneLastName = '';
    this.beneNickName = '';
    this.beneAddress = '';
    this.dob = '';
    this.telephone = '';
    this.idNumber = '';
    this.selectedIdType = '0';
    this.bankDetail.BankName = '';
    this.bankDetail.bankBranchName = '';
    this.bankDetail.bankcode = '';
    this.bankAccountNo = '';
    this.bankAddress = '';
    this.bankCode = '';
    this.selectedPayoutCurrency = '0';
    this.purposeText = '';
    this.selectedPurposeofTransfer = '0';
    this.selectedCustomerRelation = '0';
    this.beneCity = '';
    this.selectedBeneCountryCode = '0';
    this.beneCountryText = '';
    this.selectedBeneSourceofFunds = '0';
    this.selectedBeneAccountType = '0';
    this.beneZipCode = '';
    this.beneFatherSpouce = '';
    this.declaration = false;
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  print() {
    window.print();
  }

  getFullName(): string {
    const { FirstName, MiddleName, LastName } = this.customerDetail;
    return `${FirstName || ''} ${MiddleName || ''} ${LastName || ''}`.trim();
  }

  handleError(error: any): void {
    let errorMessage = 'An unexpected error occurred.';

    if (error && error.error) {
      const { title, detail, message } = error.error;
      errorMessage = `${title || 'Error'}: ${message || detail || 'Something went wrong.'
        }`;
    } else if (error.message) {
      errorMessage = `Error: ${error.message}`;
    }

    alert(errorMessage);
  }

  onCountryCodeChange(selectedItem: any): void {
    if (selectedItem) {
      this.selectedBeneCountryCodePhone = selectedItem.NationalityID;
      this.isoCode = selectedItem.ISOCode;
      console.log(this.isoCode, this.selectedBeneCountryCodePhone);
    } else {
      this.isoCode = null;
    }
  }

  openBankDetailModal(template: TemplateRef<any>) {
    this.bankName = '';
    this.branchName = '';
    this.bsViewBankDetailModalRef = this.modalService.show(template, {
      class: 'modal-lg',
    });
  }

  checkFormValidity(): void {
    this.isFormValid = this.bankName.length >= 4 || this.branchName.length >= 4;
  }

  searchBankDetail() {
    if (!this.bankName && !this.branchName) {
      alert('Please enter Bank Name or Branch Name.');
      return;
    }

    const countryCode = this.selectedBeneCountryCode || 0;

    this.bankDetails = [];

    this.EditBeneficiaryRegistrationSvc.getBankDetail(
      countryCode,
      this.bankName,
      this.branchName
    ).subscribe({
      next: (res: any) => {
        if (!res || res.length === 0) {
          alert('No data found.');
        } else {
          this.bankDetails = res;
        }
      },
      error: (err: any) => {
        const errorMessage =
          err?.error?.message ||
          'An error occurred while fetching bank details.';
        // alert(errorMessage);
        this.toastrSvc.error(errorMessage);
      },
      complete: () => { },
    });
  }
}
