import { Component } from '@angular/core';
import { CountryMandatoryFieldService } from '../country-mandatory-field.service';

@Component({
  selector: 'app-country-mandatory-field',
  templateUrl: './country-mandatory-field.component.html',
  styleUrls: ['./country-mandatory-field.component.css'],
})
export class CountryMandatoryFieldComponent {
  countryMandatoryField: any;
  countryType: any;
  selectedCountrType: any = '0';
  countryMandatory: any = '0';
  countryModeOfPayment: any;
  gridList: any;
  countryList: any;
  CountryID: any;
  PermissionID: any;
  ModeOfPayment_ID: any;
  isLoading: boolean = false;

  constructor(private countryMandatoryFieldSVC: CountryMandatoryFieldService) {}

  ngOnInit(): void {
    this.getTypesOfMandatory();
  }

  getTypesOfMandatory() {
    this.isLoading = true;
    this.countryMandatoryFieldSVC.getTypesOfMandatory().subscribe((res) => {
      this.countryMandatoryField = res;
      this.isLoading = false;
    });
  }

  getCountryType() {
    this.isLoading = true;
    this.countryMandatoryFieldSVC.getCountryType().subscribe((res) => {
      this.countryType = res;
      this.isLoading = false;
    });
  }

  getCountrylist(CountryType) {
    this.isLoading = true;
    this.countryMandatoryFieldSVC
      .getCountryList(CountryType)
      .subscribe((res) => {
        this.countryList = res;
        this.isLoading = false;
      });
  }

  getModeOfPayment(CountryID: any) {
    this.isLoading = true;
    this.countryMandatoryFieldSVC
      .getModeOfPayment(CountryID)
      .subscribe((res) => {
        this.countryModeOfPayment = res;
        this.isLoading = false;
      });
  }

  getGrid() {
    if (this.countryMandatory == '0') {
      alert('Please Select Type of Mandatory.');
      return;
    }

    if (this.selectedCountrType == '0') {
      alert('Please Select Country Type.');
      return;
    }
    if (this.countryMandatory && this.PermissionID) {
      this.isLoading = true;
      this.countryMandatoryFieldSVC
        .getGrid(
          this.countryMandatory,
          this.PermissionID,
          this.CountryID ? this.CountryID : '-1',
          this.ModeOfPayment_ID ? this.ModeOfPayment_ID : '-1'
        )
        .subscribe((res: any) => {
          if (res?.length == 0) {
            alert('No data found.');
            return;
          }
          this.gridList = res;
          this.isLoading = false;
        });
    }
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  onSelectTypesOfMandatory($event: any) {
    this.countryMandatory = $event.target.value;
    this.getCountryType();
  }

  onSelectCountryType(CountryType: any) {
    this.PermissionID = CountryType.target.value;
    this.getCountrylist(CountryType.target.value);
  }

  onSelectCountryList(CountryID: any) {
    this.CountryID = CountryID.target.value;
    this.getModeOfPayment(CountryID.target.value);
  }

  onSelectModeOfPayment(ModeOfPaymentID: any) {
    this.ModeOfPayment_ID = ModeOfPaymentID.target.value;
  }
}
