import { Component, TemplateRef, ViewChild } from '@angular/core';
import { ManageCifWiseCommissionService } from '../manage-cif-wise-commission.service';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';
import { AgentWiseCommissionService } from '../services/agent-wise-commission.service';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { getCacheData } from '../utils/helper';
import { ToastrService } from 'ngx-toastr';

@Component({
  selector: 'app-manage-cif-wise-comission',
  templateUrl: './manage-cif-wise-comission.component.html',
  styleUrls: ['./manage-cif-wise-comission.component.css'],
})
export class ManageCifWiseComissionComponent {
  @ViewChild('ManageCifWiseComissionModel') ManageCifWiseComissionModel;
  sendCountry: any;
  showCheckbox: boolean = false;
  additionalCheckboxControlCheck: any = false
  countryID: any;
  isLoading: boolean = false; // Loader flag

  CurType: any = [];
  CurrencyType: any;
  sendCurrencyType: any = [];
  sendAgent: any;
  type: any;
  receiveCurrencyType: any = [];
  receiveCountryList: any;
  receiveAgentList: any;
  ReceiveAgentInsertList: any;
  receiveCountryID: any;
  modeOfPayment: any;
  RangeCurrency: any;
  ReceiveAgentID: any;
  subAgentList: any;
  modeOfPaymentID: any;
  agentID: any;
  allRecord: any;
  subAgentID: any = -2;
  sendCountryInsertList: any;
  insertReceiveCountryList: any;
  bsModalRef: BsModalRef;
  PayInCountryId: any;
  selectReceiveCurrencyID: any;
  sendAgentInsertList: any;
  ReceiveAgentInsert: any;
  sendCurrencyInsertList: any;
  TotalCommissionType: any;
  ModeOfPaymentInsert: any;
  Agent_ID: any;
  ReceiveSubAgentInsertList: any;
  cifNumber: any;
  insertReceiveCurrencyList: any;
  ManageCifWiseCommissionForm = new FormGroup({
    PayInCountryId: new FormControl('None', Validators.required),
    AgentID: new FormControl('None', Validators.required),
    additionalCheckboxControl: new FormControl(false),
    PayInCurrencyID: new FormControl('None', Validators.required),
    PayOutCountryId: new FormControl('None', Validators.required),
    PayOutCurrencyID: new FormControl('None', Validators.required),
    ModeOfPayment_ID: new FormControl('None', Validators.required),
    CIFNumber: new FormControl('None', Validators.required),
    StartRange: new FormControl('', Validators.required),
    EndRange: new FormControl('', Validators.required),
    BaseToBaseCommissionAmount: new FormControl('', Validators.required),
    PayCommissionType: new FormControl('None', Validators.required),
    PayInCommissionType: new FormControl('None', Validators.required),
    PayInCurrencyType: new FormControl('None', Validators.required),
    PayInCommissionAmount: new FormControl('', Validators.required),
    PayOutCommissionType: new FormControl('None', Validators.required),
    PayOutCurrencyType: new FormControl('None', Validators.required),
    PayOutCommissionAmount: new FormControl('', Validators.required),
    IschkMinMax: new FormControl('', Validators.required),
    ReceiverFixAmount: new FormControl('', Validators.required),
    ReceiverMinAmount: new FormControl('', Validators.required),
    ReceiverMaxAmount: new FormControl('', Validators.required),
    RecAgentID: new FormControl('None', Validators.required),
    SubAgentID: new FormControl('None', Validators.required),
    IsSubAgent: new FormControl('', Validators.required),
    RangeCurrencyType: new FormControl('None', Validators.required),
    EnteredBy: new FormControl('', Validators.required),
    ID: new FormControl('', Validators.required),
    FixedAmount: new FormControl(''),
    MinAmount: new FormControl(''),
    MaxAmount: new FormControl(''),
  });
  constructor(
    private ManageCifWiseComissionSvc: ManageCifWiseCommissionService,
    private modalService: BsModalService,
    private agentWiseCommissionSvc: AgentWiseCommissionService,
    private toastrSvc: ToastrService

  ) { }

  ngOnInit(): void {
    this.getSendCountry();
    this.getModeOfPayment();
  }

  openModal(template: TemplateRef<any>) {
    this.bsModalRef = this.modalService.show(template, {
      class: 'modal-lg',
    });
  }
  openManageCifWiseComissionModel(type: any) {
    this.type = type;
    console.log("ss", type)
    if (type == 'add') {
      this.ManageCifWiseCommissionForm.reset({
        PayInCountryId: 'None',
        AgentID: 'None',
        ModeOfPayment_ID: 'None',
        CIFNumber: 'None',
        PayInCurrencyID: 'None',
        PayOutCountryId: 'None',
        PayOutCurrencyID: 'None',
        RecAgentID: 'None',
        SubAgentID: null,
        RangeCurrencyType: 'None',
        StartRange: '',
        EndRange: '',
        BaseToBaseCommissionAmount: '',
        PayCommissionType: 'None',
        PayInCommissionType: 'None',
        PayInCurrencyType: 'None',
        PayInCommissionAmount: '',
        PayOutCommissionType: 'None',
        PayOutCurrencyType: 'None',
        PayOutCommissionAmount: '',
      });

      this.openModal(this.ManageCifWiseComissionModel);
      this.getInsertReceiveCountry();
      this.getSendCountryInsert();
      this.getCifNumber();
      this.getTotalCommissionType();
    } else {
      this.openModal(this.ManageCifWiseComissionModel);

    }

  }
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  getSendCountry() {
    this.ManageCifWiseComissionSvc.getSendCountry().subscribe((res) => {
      this.sendCountry = res[0].Country;
    });
  }

  onSelectCountry($event) {
    this.countryID = $event.target.value;
    this.getSendAgent(this.countryID);
    this.getReceiveCountryList(this.countryID);
    this.getReceiveAgentList(this.countryID);
  }

  getSendAgent(CountryID: any) {
    this.ManageCifWiseComissionSvc.getSendAgent(CountryID).subscribe((res) => {
      this.sendAgent = res;
    });
  }

  onSelectAgent($event) {
    this.agentID = $event.target.value;
  }
  getReceiveCountryList(CountryID: any) {
    this.ManageCifWiseComissionSvc.getReceiveCountryList(CountryID).subscribe(
      (res) => {
        this.receiveCountryList = res;
      }
    );
  }

  onSelectReceiveCountry(input: any) {
    let selectedValue: string;

    if (typeof input === 'object' && input.target) {
      selectedValue = input.target.value;
    } else {
      selectedValue = input;
    }

    this.receiveCountryID = selectedValue;
    this.getReceiveAgentList(this.receiveCountryID);
    this.getReceiveCurrencyInsert(this.receiveCountryID);
  }

  getReceiveAgentList(CountryID: any) {
    this.ManageCifWiseComissionSvc.getReceiveAgentList(CountryID).subscribe(
      (res) => {
        this.receiveAgentList = res;
      }
    );
  }
  onSelectReceiveAgent($event) {
    this.ReceiveAgentID = $event.target.value;
    this.getSubAgentList(this.ReceiveAgentID);
  }

  getModeOfPayment() {
    this.ManageCifWiseComissionSvc.getModeOfPayment().subscribe((res) => {
      this.modeOfPayment = res;
    });
  }

  onSelectModeOfPayment($event) {
    this.modeOfPaymentID = $event.target.value;
  }

  getSubAgentList(ReceAgentID: any) {
    this.ManageCifWiseComissionSvc.getSubAgentList(ReceAgentID).subscribe(
      (res) => {
        this.subAgentList = res;
      }
    );
  }

  onSelectSubAgent($event) {
    this.subAgentID = $event.target.value;
  }

  getAllRecord() {
    // Assuming this.ManageCifWiseComissionSvc is your service
    this.isLoading = true; // Show loader before making request

    this.ManageCifWiseComissionSvc.getAllRecord(
      this.ReceiveAgentID || '0',
      this.countryID || '0',
      this.receiveCountryID || '0',
      this.agentID || '0',
      this.modeOfPaymentID || '0',
      this.subAgentID || '-2'
    ).subscribe({
      next: (res: any) => {
        this.isLoading = false; // Hide loader on successful response
        if (res?.length === 0) {
          alert('No data found.');
          return;
        }
        this.allRecord = res;
        // Additional processing if needed
      },
      error: (err) => {
        this.isLoading = false; // Hide loader on error
        console.error('Error fetching data:', err);
        // Handle error as needed
      }
    });
  }


  deleteRecord() {
    const payload = this.isDeleted();
    this.ManageCifWiseComissionSvc.deleteRecord(payload)
      .subscribe({
        next: (res: any) => {
          this.getAllRecord();
          this.toastrSvc.success('Record Deleted successfully!');
        },
        error: (err) => {
          // alert(err?.error?.message || 'Something went wrong');
          this.toastrSvc.error(err?.error?.message)
        },
        complete: () => {
        },
      });
  }

  isDeleted() {
    return this.allRecord
      .filter((con) => con.isDeleted)
      .map((con) => ({
        ID: con?.ID,
        RecSubAgent: this.subAgentID,
      }));
  }

  getSendCountryInsert() {
    this.ManageCifWiseComissionSvc.getSendCountryInsert().subscribe((res) => {
      this.sendCountryInsertList = res;
    });
  }

  onSelectSendCountryInsert(input: any) {
    let selectedValue: string;

    if (typeof input === 'object' && input.target) {
      selectedValue = input.target.value;
    } else {
      selectedValue = input;
    }

    this.PayInCountryId = selectedValue;
    this.getSendAgentInsert(this.PayInCountryId);
    this.getSendCurrencyInsert(this.PayInCountryId);
  }


  getSendAgentInsert(PayInCountryId: any) {
    this.ManageCifWiseComissionSvc.getSendAgentInsert(PayInCountryId).subscribe(
      (res) => {
        this.sendAgentInsertList = res;
      }
    );
  }
  onSelectAddAgent($event) {
    this.Agent_ID = $event.target.value;
    this.getModeOfPaymentInsert();
  }

  getSendCurrencyInsert(countryId: any) {
    this.ManageCifWiseComissionSvc.getSendCurrencyInsert(countryId).subscribe(
      (res) => {
        this.sendCurrencyInsertList = res;
      }
    );
  }

  getModeOfPaymentInsert() {
    this.ManageCifWiseComissionSvc.getModeOfPaymentInsert().subscribe((res) => {
      this.ModeOfPaymentInsert = res;
    });
  }

  getCifNumber() {
    this.ManageCifWiseComissionSvc.getCifNumber().subscribe((res) => {
      this.cifNumber = res;
    });
  }

  getInsertReceiveCountry() {
    this.ManageCifWiseComissionSvc.getInsertReceiveCountry().subscribe(
      (res) => {
        this.insertReceiveCountryList = res;
      }
    );
  }

  getSendAgentInsertList(currencyId: any, countryId: any) {
    this.ManageCifWiseComissionSvc.getSendAgentInsertList(
      currencyId,
      countryId
    ).subscribe((res) => {
      res;
    });
  }

  getReceiveCurrencyInsert(payOutCountryId: any) {
    this.ManageCifWiseComissionSvc.getReceiveCurrencyInsert(
      payOutCountryId
    ).subscribe((res) => {
      this.insertReceiveCurrencyList = res;
    });
  }

  onSelectReceiveCurrency($event) {
    this.selectReceiveCurrencyID = $event.target.value;
    this.getReceiveAgentInsert(
      this.selectReceiveCurrencyID,
      this.receiveCountryID
    );
    this.getRangeCurrency();
    const sendCurrencyType = this.insertReceiveCurrencyList?.find(
      (currency) => currency?.Currency_Id === parseInt($event.target.value)
    );

    this.CurrencyType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency.Currency_Id,
        CurrencyType: currency.CurrencyShortName,
        // Add more key renaming as needed
      };
    });
  }

  getReceiveAgentInsert(receiveCurrencyId: any, payOutCountryId: any) {
    this.ManageCifWiseComissionSvc.getReceiveAgentInsert(
      receiveCurrencyId,
      payOutCountryId
    ).subscribe((res) => {
      this.ReceiveAgentInsertList = res;
    });
  }

  onSelectReceiveAgentID($event) {
    console.log($event)
    this.getReceiveSubAgentInsert($event.target.value);
  }

  getReceiveSubAgentInsert(agentId) {
    this.ManageCifWiseComissionSvc.getReceiveSubAgentInsert(agentId).subscribe(
      (res) => {
        this.ReceiveSubAgentInsertList = res;
        console.log('res: ', res);
      }
    );
  }
  getRangeCurrencyInsert() {
    this.ManageCifWiseComissionSvc.getRangeCurrencyInsert().subscribe((res) => {
      this.RangeCurrency = res;
      this.sendCurrencyType = res;
      if (!this.areArraysEqual(this.sendCurrencyType, this.CurType)) {
        this.sendCurrencyType = this.sendCurrencyType.concat(this.CurType);
      }
    });
  }

  getRangeCurrency() {
    this.ManageCifWiseComissionSvc.getRangeCurrencyInsert().subscribe((res) => {
      this.receiveCurrencyType = res;
      if (!this.areArraysEqual(this.receiveCurrencyType, this.CurrencyType)) {
        this.receiveCurrencyType = this.receiveCurrencyType.concat(
          this.CurrencyType
        );
      }
    });
  }

  onSelectSendCurrency($event) {
    this.getRangeCurrencyInsert();


    const sendCurrencyType = this.sendCurrencyInsertList?.find(
      (currency) => currency?.Currency_Id === parseInt($event.target.value)
    );

    this.CurType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency.Currency_Id,
        CurrencyType: currency.CurrencyShortName,
        // Add more key renaming as needed
      };
    });

    if (!this.areArraysEqual(this.sendCurrencyType, this.CurType)) {

      this.sendCurrencyType = this.sendCurrencyType.concat(this.CurType);
      console.log(this.sendCurrencyType, "aaa")
    }
  }

  areArraysEqual(sendCurrencyType, currency) {
    if (sendCurrencyType.length !== currency.length) {
      return false;
    }
    sendCurrencyType.sort();
    currency.sort();
    for (let i = 0; i < sendCurrencyType.length; i++) {
      for (let key in sendCurrencyType[i]) {
        if (sendCurrencyType[i][key] !== currency[i][key]) {
          return false;
        }
      }
    }
    return true;
  }

  get f() {
    return this.ManageCifWiseCommissionForm.value;
  }

  addRecord(type: any) {
    this.type = type;
    console.log('this.f.SubAgentID: ', this.f.SubAgentID);
    const payload = {
      AgentID: Number(this.f.AgentID) || 0,
      BaseToBaseCommissionAmount: Number(this.f.BaseToBaseCommissionAmount),
      CIFNumber: this.f.CIFNumber,
      EndRange: Number(this.f.EndRange),
      EnteredBy: getCacheData('G_UserID'),
      ID: Number(0),
      IsSubAgent: this.f.SubAgentID ? true : false,
      IschkMinMax: this.f.additionalCheckboxControl || false,
      ModeOfPayment_ID: Number(this.f.ModeOfPayment_ID) || 0,
      PayCommissionType: Number(this.f.PayCommissionType),
      PayInCommissionAmount: Number(this.f.PayInCommissionAmount),
      PayInCommissionType: Number(this.f.PayInCommissionType),
      PayInCountryId: Number(this.f.PayInCountryId),
      PayInCurrencyID: Number(this.f.PayInCurrencyID) || 0,
      PayInCurrencyType: Number(this.f.PayInCurrencyType) || 0,
      PayOutCommissionAmount: Number(this.f.PayOutCommissionAmount),
      PayOutCommissionType: Number(this.f.PayOutCommissionType),
      PayOutCountryId: Number(this.f.PayOutCountryId),
      PayOutCurrencyID: Number(this.f.PayOutCurrencyID) || 0,
      PayOutCurrencyType: Number(this.f.PayOutCurrencyType) || 0,
      RangeCurrencyType: Number(this.f.RangeCurrencyType) || 0,
      RecAgentID: Number(this.f.RecAgentID) || 0,
      ReceiverFixAmount: Number(this.f.FixedAmount) || 0,
      ReceiverMaxAmount: Number(this.f.MaxAmount) || 0,
      ReceiverMinAmount: Number(this.f.MinAmount) || 0,
      StartRange: Number(this.f.StartRange),
      SubAgentID: this.f.SubAgentID,
    };
    if (this.f.PayInCountryId == 'None') {
      alert('Please Select Send Country !');
      return;
    }
    if (this.f.CIFNumber == 'None') {
      alert('Please Select CIF Number!');
      return;
    }
    if (this.f.PayOutCountryId == 'None') {
      alert('Please Select Receive Country!');
      return;
    }

    if (this.f.StartRange == '') {
      alert('Please Enter Start Range Amount!!');
      return;
    }

    if (this.f.EndRange == '') {
      alert('Please Enter End Range Amount!');
      return;
    }
    if (this.f.EndRange < this.f.StartRange) {
      alert('End Range should be greater than Start Range!');
      return;
    }
    if (this.f.BaseToBaseCommissionAmount == '') {
      alert('Please Total Commission Amount!');
      return;
    }
    if (this.f.PayCommissionType == 'None') {
      alert('Please Select Total Commission Type!');
      return;
    }
    if (this.f.PayInCommissionType == 'None') {
      alert('Please Select Send Commission Type!');
      return;
    }
    // if (this.f.PayInCommissionAmount == '') {
    //   alert('Please Enter Send Commission Amount!');
    //   return;
    // }
    if (this.f.PayOutCommissionType == 'None') {
      alert('Please Select Receive Commission Type!');
      return;
    }

    if (this.f.PayOutCommissionAmount == '') {
      alert('Please Enter Receive Commission Amount!');
      return;
    }
    if (type == 'Add') {
      this.ManageCifWiseComissionSvc.addRecord(payload).subscribe({
        next: (res: any) => {
          this.modalService.hide();
          // alert(res);
          this.toastrSvc.success(res);
          this.getAllRecord();
        },
        error: (error) => {
          // Display the error message in an alert
          if (error?.error?.message) {
            // window.alert(error.error.message);
            this.toastrSvc.error(error.error.message);
          } else {
            // window.alert('An unknown error occurred.');
            this.toastrSvc.error('An unknown error occurred.');
          }
        }
      });

    }

    if (type == 'Update') {

      console.log(this.f.additionalCheckboxControl)

      if (this.f.additionalCheckboxControl) { // Check if the checkbox control is true
        // Validate FixedAmount
        if (this.f.FixedAmount === '') {
          alert('Please Enter Fixed Amount!');
          return;
        }

        // Validate MinAmount
        if (this.f.MinAmount === '') {
          alert('Please Enter Min Amount!');
          return;
        }

        // Validate MaxAmount
        if (this.f.MaxAmount === '') {
          alert('Please Enter Max Amount!');
          return;
        }

        // Convert MinAmount and MaxAmount to numbers to ensure numeric comparison
        const minAmount = parseFloat(this.f.MinAmount);
        const maxAmount = parseFloat(this.f.MaxAmount);


        if (maxAmount <= minAmount) {
          alert('Max Amount should be greater than Min Amount!');
          return;
        }
      } else {
        this.ManageCifWiseCommissionForm.patchValue({
          additionalCheckboxControl: false,
          FixedAmount: "0",
          MinAmount: "0",
          MaxAmount: "0",
        });
      }

      // Proceed with the rest of your code if all validations pass

      console.log(this.f.additionalCheckboxControl)


      const payload = {
        AgentID: Number(this.f.AgentID),
        BaseToBaseCommissionAmount: Number(this.f.BaseToBaseCommissionAmount),
        CIFNumber: this.f.CIFNumber,
        EndRange: Number(this.f.EndRange),
        EnteredBy: getCacheData('G_UserID'),
        ID: Number(this.f.ID),
        IsSubAgent: this.f.SubAgentID ? true : false,
        IschkMinMax: this.f.additionalCheckboxControl || false,

        ModeOfPayment_ID: Number(this.f.ModeOfPayment_ID),
        PayCommissionType: Number(this.f.PayCommissionType),
        PayInCommissionAmount: Number(this.f.PayInCommissionAmount),
        PayInCommissionType: Number(this.f.PayInCommissionType),
        PayInCountryId: Number(this.f.PayInCountryId),
        PayInCurrencyID: Number(this.f.PayInCurrencyID),
        PayInCurrencyType: Number(this.f.PayInCurrencyType),
        PayOutCommissionAmount: Number(this.f.PayOutCommissionAmount),
        PayOutCommissionType: Number(this.f.PayOutCommissionType),
        PayOutCountryId: Number(this.f.PayOutCountryId),
        PayOutCurrencyID: Number(this.f.PayOutCurrencyID),
        PayOutCurrencyType: Number(this.f.PayOutCurrencyType),
        RangeCurrencyType: Number(this.f.RangeCurrencyType),
        RecAgentID: Number(this.f.RecAgentID),

        StartRange: Number(this.f.StartRange),
        SubAgentID: Number(this.f.SubAgentID),
        ReceiverFixAmount: Number(this.f.FixedAmount) || 0,
        ReceiverMinAmount: Number(this.f.MinAmount) || 0,
        ReceiverMaxAmount: Number(this.f.MaxAmount) || 0,

      };
      this.ManageCifWiseComissionSvc.updateRecord(payload)
        .subscribe({
          next: (res: any) => {
            this.getAllRecord();
            this.modalService.hide();
            this.toastrSvc.success(res);
          },
          error: (err) => {
            // alert(err?.error?.message || 'Something went wrong');
            this.modalService.hide();

            this.toastrSvc.error(err?.error?.message)
          },
          complete: () => {
            this.modalService.hide();
          },
        });
    }
  }
  getTotalCommissionType() {
    this.ManageCifWiseComissionSvc.getTotalCommissionType().subscribe((res) => {
      this.TotalCommissionType = res;
    });
  }
  async edit(ID, IsSubAgent, type = 'edit') {
    this.type = type;
    try {
      const res = await this.ManageCifWiseComissionSvc.edit(ID, this.subAgentID).toPromise();


      const data = res[0];

      this.onSelectSendCountryInsert(data.PayInCountryId);


      this.onEditSendCurrencyType(data.PayInCurrencyID);
      this.onSelectReceiveCountry(data.PayOutCountryId)

      this.ManageCifWiseCommissionForm.patchValue({
        PayInCountryId: data.PayInCountryId,
        AgentID: data.Agent_ID || "0",
        ModeOfPayment_ID: data.ModeOfPayment_ID,
        CIFNumber: data.CIFNumber,
        PayInCurrencyID: data.PayInCurrencyID,
        PayOutCountryId: data.PayOutCountryId,
        PayOutCurrencyID: data.PayOutCurrencyID,
        RecAgentID: data.ReceivingAgent ?? 'None',
        RangeCurrencyType: data.RangeCurrencyType,
        StartRange: data.StartRange,
        EndRange: data.EndRange,
        BaseToBaseCommissionAmount: data.BaseToBaseCommissionAmount,
        PayCommissionType: data.PayCommissionType,
        PayInCommissionType: data.PayInCommissionType,
        PayInCurrencyType: data.PayInCurrencyType,
        PayInCommissionAmount: data.PayInCommissionAmount,
        PayOutCommissionType: data.PayOutCommissionType,
        PayOutCurrencyType: data.PayOutCurrencyType,
        PayOutCommissionAmount: data.PayOutCommissionAmount,
        ID: data.ID,
        ReceiverFixAmount: data.PayOutFixAmount,
        ReceiverMinAmount: data.PayOutMinAmount,
        ReceiverMaxAmount: data.PayOutMaxAmount,
        additionalCheckboxControl: data.IsPayOutMinMax,
        FixedAmount: data.PayOutFixAmount,
        MinAmount: data.PayOutMinAmount,
        MaxAmount: data.PayOutMaxAmount,
        SubAgentID: data.SendingAgent || -1,
      });

      this.showCheckbox = data.IsPayOutMinMax;
      this.additionalCheckboxControlCheck = this.showCheckbox ? data.IsPayOutMinMax : '';
      this.getInsertReceiveCountry();
      this.getSendCountryInsert();
      this.getCifNumber();
      this.getModeOfPaymentInsert();
      this.getTotalCommissionType();
      this.getSendAgentInsert(this.f.PayInCountryId);
      this.getSendCurrencyInsert(this.f.PayInCountryId);
      this.getReceiveCurrencyInsert(this.f.PayOutCountryId);
      this.getReceiveAgentInsert(this.f.PayOutCurrencyID, this.f.PayOutCountryId);
      this.getReceiveSubAgentInsert(data.ReceivingAgent);

      await this.updateCurrencyTypeLists(data.PayOutCurrencyID, data.PayInCurrencyID);
      // this.onEditReceiveCurrencyType(this.f.PayOutCurrencyType);
      await this.onEditReceiveCurrencyTypeValue(data.PayOutCurrencyID)
      await new Promise(resolve => setTimeout(resolve, 1000)); // Adjust the delay as needed

      this.openManageCifWiseComissionModel('edit');
    } catch (error) {
      console.error('Error editing CIF wise commission', error);
    }
  }

  async onEditReceiveCurrencyTypeValue(id) {
    let filteredCurrencies = this.insertReceiveCurrencyList
      .filter(currency => currency.Currency_Id == id)
      .map(currency => ({
        ID: currency.Currency_Id,
        CurrencyType: currency.CurrencyShortName
      }));
    this.receiveCurrencyType = [...filteredCurrencies, { ID: 1, CurrencyType: 'USD' }];
    console.log(filteredCurrencies, "s", this.receiveCurrencyType)
    this.receiveCurrencyType = this.receiveCurrencyType.reduce((unique, o) => {
      if (!unique.some(obj => obj.ID === o.ID)) {
        unique.push(o);
      }
      return unique;
    }, []);

  }

  async updateCurrencyTypeLists(PayOutCurrencyID, PayInCurrencyID) {
    if (PayOutCurrencyID !== 0) {
      await this.updateCurrencyTypeList(PayOutCurrencyID, this.insertReceiveCurrencyList, this.receiveCurrencyType);
    }
    if (PayInCurrencyID !== 0) {
      await this.updateCurrencyTypeList(PayInCurrencyID, this.sendCurrencyInsertList, this.sendCurrencyType);
    }
  }

  async updateCurrencyTypeList(currencyID, currencyList, currencyTypeArray) {
    const dropValue = currencyList.find(c => c.Currency_Id === currencyID);
    if (dropValue) {
      const transformedCurrency = {
        ID: dropValue.Currency_Id,
        CurrencyType: dropValue.CurrencyShortName
      };
      if (!currencyTypeArray.some(c => c.ID === transformedCurrency.ID)) {
        await new Promise(resolve => setTimeout(resolve, 1000));
        currencyTypeArray.push(transformedCurrency);

        const uniqueCurrencies = new Map();
        currencyTypeArray.forEach(currency => {
          if (currency.ID !== undefined && currency.CurrencyType !== undefined) {
            uniqueCurrencies.set(currency.ID, currency);
          }
        });
        currencyTypeArray.splice(0, currencyTypeArray.length, ...Array.from(uniqueCurrencies.values()));
        console.log(currencyTypeArray, 'Updated Currency List', transformedCurrency);
      }
    }
  }


  get checkType() {
    let type = this.type;
    switch (type) {
      case 'add':
        return (type = 'Add');
      case 'edit':
        return (type = 'Update');
      default:
        return type;
    }
  }
  onEditSendCurrencyType(id: any) {
    this.getRangeCurrencyInsert();

    const sendCurrencyType = this.sendCurrencyInsertList?.find(
      (currency) => currency?.Currency_Id == parseInt(id)
    );
    console.log(sendCurrencyType, "test")
    this.CurType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency?.Currency_Id,
        CurrencyType: currency?.CurrencyShortName,
        // Add more key renaming as needed
      };
    });

    if (!this.areArraysEqual(this.sendCurrencyType, this.CurType)) {
      this.sendCurrencyType = this.sendCurrencyType.concat(this.CurType);
    }
  }

  onEditReceiveCurrencyType(id: any) {
    this.getRangeCurrency();

    const sendCurrencyType = this.insertReceiveCurrencyList?.find(
      (currency) =>
        currency?.Currency_Id == parseInt(id)
    );

    this.CurrencyType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency?.Currency_Id,
        CurrencyType: currency?.CurrencyShortName,
      };
    });
    if (this.f.PayOutCurrencyType == 'None') {
    } else {
      this.openManageCifWiseComissionModel('edit');
    }
  }
  Reset() {
    this.ManageCifWiseCommissionForm.reset({
      PayInCountryId: 'None',
      AgentID: 'None',
      ModeOfPayment_ID: 'None',
      CIFNumber: 'None',
      PayInCurrencyID: 'None',
      PayOutCountryId: 'None',
      PayOutCurrencyID: 'None',
      RecAgentID: 'None',
      SubAgentID: null,
      RangeCurrencyType: 'None',
      StartRange: '',
      EndRange: '',
      BaseToBaseCommissionAmount: '',
      PayCommissionType: 'None',
      PayInCommissionType: 'None',
      PayInCurrencyType: 'None',
      PayInCommissionAmount: '',
      PayOutCommissionType: 'None',
      PayOutCurrencyType: 'None',
      PayOutCommissionAmount: '',
    });
  }


  onCommissionTypeChange(event: any) {
    const selectedValue = event.target.value;

    console.log(selectedValue)

    if (selectedValue == 2) {
      this.showCheckbox = !!selectedValue; // or any other condition
    } else {
      this.additionalCheckboxControlCheck = false
      this.showCheckbox = false;

      this.ManageCifWiseCommissionForm.patchValue({

        additionalCheckboxControl: false,

      });// or any other condition
    }

  }

  onCheckboxChange(event: any) {
    const isChecked = event.target.checked;
    this.additionalCheckboxControlCheck = isChecked

  }




}
