import { Component, ViewChild, TemplateRef } from '@angular/core';
import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
import { RejectedBeneficiaryService } from '../rejected-beneficiary.service';
import { getCacheData } from '../utils/helper';
import { EditBeneficiaryRegistrationService } from '../edit-beneficiary-registration.service';
import { ToastrService } from 'ngx-toastr';

@Component({
  selector: 'app-rejected-beneficiary',
  templateUrl: './rejected-beneficiary.component.html',
  styleUrls: ['./rejected-beneficiary.component.css'],
})
export class RejectedBeneficiaryComponent {
  bsModalRef: BsModalRef;

  @ViewChild('updateBeneficiaryRegistration')
  manageagentuserTemplate: TemplateRef<any>;

  @ViewChild('viewBankDetail') viewBankDetailModal;
  bsViewBankDetailModalRef: BsModalRef;

  CustomerNumber: any;
  allData: any = [];
  selectedCriteria: any = 4;
  beneficiaryNumber: any = '';
  nickName: any = '';
  startDate: any = '';
  endDate: any = '';
  PayoutCurrency: any;
  PhoneCode: any;
  PurposeOfTransfer: any;
  IdTypeList: any;
  SourceOfFund: any;
  AccountTypeList: any;
  Relationship: any;
  editCustomer: any;
  bankDetails: any = [];
  bankName: any = '';
  branchName: any = '';
  isFormValid: boolean = false;

  constructor(
    private modalService: BsModalService,
    private RejectedBeneficiarySvc: RejectedBeneficiaryService,
    private EditBeneficiaryRegistrationSvc: EditBeneficiaryRegistrationService,
    private toastrSvc: ToastrService
  ) { }

  ngOnInit(): void {
    this.search();
    this.getRelationship();
    this.getAccountTypeList();
    this.getAccountTypeList();
    this.getSourceOfFund();
    this.getIdTypeList();
    this.getPurposeOfTransfer();
    this.getPhoneCode();
  }

  search() {
    if (this.selectedCriteria == 5 && !this.beneficiaryNumber) {
      alert('Please Enter Beneficiary No.');
      return;
    }

    if (this.selectedCriteria == 6 && !this.nickName) {
      alert('Please Enter Nick Name.');
      return;
    }

    if (this.selectedCriteria == 7 && !this.startDate && !this.endDate) {
      alert('Please Enter Start and End Dates.');
      return;
    }
    if (this.selectedCriteria == 4) {
      this.RejectedBeneficiarySvc.getCustomer(
        this.selectedCriteria,
        this.startDate,
        this.endDate,
        this.beneficiaryNumber
      ).subscribe((res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res;
      });
    }
    if (this.selectedCriteria == 5) {
      this.RejectedBeneficiarySvc.getCustomer(
        this.selectedCriteria,
        this.startDate,
        this.endDate,
        this.beneficiaryNumber
      ).subscribe((res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res;
      });
    }
    if (this.selectedCriteria == 6) {
      this.beneficiaryNumber = '';
      this.RejectedBeneficiarySvc.getCustomer(
        this.selectedCriteria,
        this.startDate,
        this.endDate,
        this.nickName
      ).subscribe((res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res;
      });
    }
    if (this.selectedCriteria == 7) {
      this.beneficiaryNumber = '';
      this.nickName = '';
      this.RejectedBeneficiarySvc.getCustomer(
        this.selectedCriteria,
        this.startDate,
        this.endDate,
        this.beneficiaryNumber || this.nickName
      ).subscribe((res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res;
      });
    }
  }

  onSelectCountryCode(CountryCode) {
    this.getPayoutCurrency(CountryCode);
  }

  getPayoutCurrency(CountryCode) {
    this.RejectedBeneficiarySvc.getCurrency(CountryCode).subscribe((res) => {
      this.PayoutCurrency = res;
    });
  }

  getPhoneCode() {
    this.RejectedBeneficiarySvc.getPhoneCode().subscribe((res) => {
      this.PhoneCode = res;
    });
  }
  getPurposeOfTransfer() {
    this.RejectedBeneficiarySvc.getPurposeOfTransfer().subscribe((res) => {
      this.PurposeOfTransfer = res;
    });
  }

  getIdTypeList() {
    this.RejectedBeneficiarySvc.getIdType().subscribe((res) => {
      this.IdTypeList = res;
    });
  }

  getSourceOfFund() {
    this.RejectedBeneficiarySvc.getSourceOfFund().subscribe((res) => {
      this.SourceOfFund = res;
    });
  }

  getAccountTypeList() {
    this.RejectedBeneficiarySvc.getAccountTypeList().subscribe((res) => {
      this.AccountTypeList = res;
    });
  }

  getRelationship() {
    this.RejectedBeneficiarySvc.getRelationship().subscribe((res) => {
      this.Relationship = res;
    });
  }

  getCustomerByCustomerNumber(beneficiaryNumber) {
    this.RejectedBeneficiarySvc.getCustomerByCustomerNumber(
      beneficiaryNumber
    ).subscribe((res) => { });
  }

  edit(item) {
    this.RejectedBeneficiarySvc.edit(item?.BeneficiaryNo).subscribe((res) => {
      this.editCustomer = res?.[0];
      if (this.editCustomer.ReceiverSourceOfFund != 0) {
        const sourceOfFund = this.SourceOfFund.find(
          (s) => s.SourceOfIncomeID == this.editCustomer.ReceiverSourceOfFund
        )?.SourceOfIncomeID;
        this.editCustomer.ReceiverSourceOfFund = sourceOfFund;
      }
      if (this.editCustomer.ReceiverPhoneCountryCode != 0) {
        const phoneCode = this.PhoneCode.find(
          (s) => s.ISOCode == this.editCustomer.ReceiverPhoneCountryCode
        )?.NationalityID;
        this.editCustomer.ReceiverPhoneCountryCode = phoneCode;
      }
      this.getPayoutCurrency(this.editCustomer?.PayoutCountryCode);
      this.bsModalRef = this.modalService.show(this.manageagentuserTemplate, {
        class: 'modal-lg',
      });
    });
  }

  openBeneficiaryModal(item) {
    this.edit(item);

    // this.getRelationship();
    // this.getAccountTypeList();
    // this.getAccountTypeList();
    // this.getSourceOfFund();
    // this.getIdTypeList();
    // this.getPurposeOfTransfer();
    // this.getPhoneCode();
  }
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  update(item) {
    if (!item?.BeneficiaryNo) {
      alert('Please Fill Beneficiary No.');
      return;
    }

    if (!item?.PayoutCountryCode) {
      alert('Please Select Payout Country Code.');
      return;
    }

    if (!item?.Currency) {
      alert('Please Select Payout Currency.');
      return;
    }

    if (!item?.PaymentMode) {
      alert('Please Select Payment Mode.');
      return;
    }

    if (!item?.PurposeCode) {
      alert('Please Select Purpose of Transfer.');
      return;
    }

    const selectedPurpose = this.PurposeOfTransfer.find(
      (p) => p.PurposeOfTransferID === Number(item.PurposeCode)
    );

    if (!selectedPurpose) {
      alert('Please Select Purpose of Transfer.');
      return;
    }

    const purposeCode = selectedPurpose.PurposeOfTransferID;
    const purposeValue = selectedPurpose.PurposeOfTranfer;

    if (!item?.BeneficiaryFirstName) {
      alert('Please Fill Beneficiary First Name.');
      return;
    }

    if (!item?.BeneficiaryLastName) {
      alert('Please Fill Beneficiary Last Name.');
      return;
    }

    if (!item?.NickName) {
      alert('Please Fill Beneficiary Nick Name.');
      return;
    }

    if (!item?.BranchName) {
      alert('Please Fill Branch Name.');
      return;
    }

    if (!item?.BankName) {
      alert('Please Fill Bank Name.');
      return;
    }

    if (!item?.AccountNumber) {
      alert('Please Fill Account Number.');
      return;
    }

    if (!item?.BankBranch) {
      alert('Please Fill Branch Address.');
      return;
    }

    if (!item?.BankCode) {
      alert('Please Fill BankIFSC Code.');
      return;
    }

    const selectedPhoneCode = this.PhoneCode.find(
      (p) => p.NationalityID === Number(item.ReceiverPhoneCountryCode)
    );

    const beneficiaryPhoneCountryCodeText = selectedPhoneCode?.ISOCode
      ? selectedPhoneCode?.ISOCode
      : '';
    const beneficiaryPhoneCountryCodeValue = selectedPhoneCode?.NationalityID
      ? selectedPhoneCode?.NationalityID
      : '';

    const payload = {
      BeneficiaryNo: item?.BeneficiaryNo,
      CustomerNo: item?.CustomerNo,
      FirstName: item?.BeneficiaryFirstName,
      MiddleName: item?.BeneficiaryMiddleName,
      LastName: item?.BeneficiaryLastName,
      NickName: item?.NickName,
      BeneficiaryAddress: item?.BeneficiaryAddress,
      DOB: item?.BeneficiaryDateOfBirth,
      Telephone: item?.BeneficiaryTelephone,
      Nationality: item?.BeneficiaryNationality,
      Idnumber: item?.BeneficiaryIdnumber,
      IdType: Number(item?.BeneficiaryIdType),
      PaymentMode: item?.PaymentMode,
      BankName: item?.BankName,
      DestinationCountry: item?.PayoutCountryCode,
      BankBranch: item?.BranchName,
      BankCode: item?.BankCode,
      BankAccountNo: item?.AccountNumber,
      BankAddress: item?.BankBranch ? item?.BankBranch : '',
      BranchCode: item?.BankCode,
      BranchAddress: item?.BankBranch,
      PayoutCurrency: item?.Currency,
      PurposeText: String(purposeValue),
      Purpose: String(purposeCode),
      UserID: getCacheData('G_UserID'),
      CustomerRelation: item?.CustomerRelation,
      BeneficiaryCity: item?.ReceiverCity,
      beneficiaryPhoneCountryCodeValue: beneficiaryPhoneCountryCodeValue,
      beneficiaryPhoneCountryCodeText: beneficiaryPhoneCountryCodeText,
      BeneficiarySourceoffunds: item?.ReceiverSourceOfFund,
      BeneficiaryAccountType: item?.ReceiverAccounttype,
      BeneficiaryZipCode: item?.ReceiverZipCode,
      Declaration: item?.Declaration ? item?.Declaration : false,
      FatherSpouse: item?.FatherSpouseName,
    };

    this.EditBeneficiaryRegistrationSvc.update(payload).subscribe({
      next: (res: any) => {
        // alert('Data updated.');
        this.toastrSvc.success('Data updated.');
      },
      error: (err: any) => {
        // alert(err?.error?.message);
        this.toastrSvc.error(err?.error?.message);
        this.bsModalRef.hide();
      },
      complete: () => {
        this.bsModalRef.hide();
      },
    });
  }

  openBankDetailModal(template: TemplateRef<any>) {
    this.bsModalRef.hide();
    this.bankName = '';
    this.branchName = '';
    this.bsViewBankDetailModalRef = this.modalService.show(template, {
      class: 'modal-lg',
    });
  }

  checkFormValidity(): void {
    this.isFormValid = this.bankName.length >= 4 || this.branchName.length >= 4;
  }

  searchBankDetail() {
    if (!this.bankName && !this.branchName) {
      alert('Please enter Bank Name or Branch Name.');
      return;
    }

    const countryCode = this.editCustomer?.PayoutCountryCode || 0;

    this.bankDetails = [];

    this.EditBeneficiaryRegistrationSvc.getBankDetail(
      countryCode,
      this.bankName,
      this.branchName
    ).subscribe({
      next: (res: any) => {
        if (!res || res.length === 0) {
          alert('No data found.');
        } else {
          this.bankDetails = res;
        }
      },
      error: (err: any) => {
        const errorMessage =
          err?.error?.message ||
          'An error occurred while fetching bank details.';
        // alert(errorMessage);
        this.toastrSvc.error(errorMessage);
      },
      complete: () => { },
    });
  }
}
