import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class CancellationRequestService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getStatusList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/transection-managment/cancel-request/status-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateCancelRequest(payload: any = {}) {
    return this.http.patch(
      `${environment.apiUrl}/api/master/transection-managment/cancel-request/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
