import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class CommissionIncomeService {
  url = environment.apiUrl;

  constructor(private router: Router, private http: HttpClient) {}

  getReportType() {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/report-type`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getReportCountry() {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getReportCurrency() {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/currency`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getReportAgent(countryId:any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/agent?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportSendAgent() {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/send-agent`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportReceivingCountry() {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/rece-country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportUnpaidPrincipalGrid(FromDate: any, ToDate: any,CurrencyID:any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/grid/unpaid-principal?FromDate=${FromDate}&ToDate=${ToDate}&CurrencyID=${CurrencyID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportUnpaidCommissionGrid(FromDate: any, ToDate: any,CurrencyID:any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/grid/unpaid-commission?FromDate=${FromDate}&ToDate=${ToDate}&CurrencyID=${CurrencyID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportAgencyCommissionIncomeGrid(FromDate: any, ToDate: any,CurrencyID:any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/grid/agency-commission-income?FromDate=${FromDate}&ToDate=${ToDate}&CurrencyID=${CurrencyID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportAgencyExchangeEarningsGrid(FromDate: any, ToDate: any,AgentID:any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/grid/agency-exchange-earnings?FromDate=${FromDate}&ToDate=${ToDate}&AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportGlobalTransactionsIncomeSummaryReportGrid(FromDate: any, ToDate: any,AgentID:any,CountryID:any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/grid/global-trxns-income-summary-report?FromDate=${FromDate}&ToDate=${ToDate}&AgentID=${AgentID}&CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  ReportGlobalTransactionsIncomeSummaryCorridorwiseGrid(
    FromDate: any,
    ToDate: any,
    AgentID:any,
    CountryID:any,
    ReceCountryID:any
  ) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/finance-and-account/commission-income-report/grid/global-trxns-income-summary-corridorwise?FromDate=${FromDate}&ToDate=${ToDate}&AgentID=${AgentID}&CountryID=${CountryID}&ReceCountryID=${ReceCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
