import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ComplianceDetailService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) { }

  getComplianceDetailsReport(fromDate: any = '',
    toDate: any = '',
    statusId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/compliance-management/compliance-reports/compliance-details-report?FromDate=${fromDate}&ToDate=${toDate}&TrStatusID=${statusId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
