import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ManagePremiumMarginsService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSendCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/send-country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountryList(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/receive-country?SendCountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(payInCountryId: any = 0, payOutCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/grid?PayInCountry=${payInCountryId}&PayOutCountry=${payOutCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCountryAddList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/add/send-country?AsPerPermission=true&MyType=2`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentList(targetCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/add/send-agent?TargetCountryID=${targetCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentCurrencyList(agentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/add/agent-currency?agentID=${agentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountryAddList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/add/receive-country?MyType=1&AsPerPermission_=true`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceivingAgentList(receiveCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/add/receive-agent?CountryID=${receiveCountryId}&MyType=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCurrencyList(receiveAgentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/add/receive-currency?AgentID=${receiveAgentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getModeofPaymentList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/manage-premium-margins/add/modeofpayment`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addPremiumMargin(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/manage-premium-margins/add`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updatePremiumMargin(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/manage-premium-margins/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
