import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class RaCtaHoldTransactionService {
  constructor(private http: HttpClient) {}

  getCountry() {
    return this.http.get(
      `${
        environment.apiUrl
      }/api/transaction/ra-cta-hold-transaction/country?UserID=${getCacheData(
        'G_UserID'
      )}&GAgentID=0&AgentCountryID=1`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgents(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/ra-cta-hold-transaction/agent?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAllRecord(FromDate: any, ToDate: any, AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/ra-cta-hold-transaction/all-record?FromDate=${FromDate}&ToDate=${ToDate}&AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  preview(FromDate: any, ToDate: any, AgentID: any, payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/ra-cta-hold-transaction/preview?FromDate=${FromDate}&ToDate=${ToDate}&AgentID=${AgentID}`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  batchApproved(payload: any = {}) {
    return this.http.patch(
      `${environment.apiUrl}/api/transaction/ra-cta-hold-transaction/batch-approved`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
