import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class SendTxnsUserWiseService {
  constructor(private http: HttpClient) {}

  getSentTransactionsForSalespersonByCountry(
    G_UserID: any,
    G_Agent_ID: any,
    Agent_Country_ID: any
  ) {
    return this.http.get<any[]>(
      `${environment.apiUrl}/api/master/reports/all-sent-trxn-for-salesp-report/sendcountry?G_UserID=${G_UserID}&G_Agent_ID=${G_Agent_ID}&Agent_Country_ID=${Agent_Country_ID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSentTransactionsForSalespersonByAgent(agentId: any, countryId: any) {
    return this.http.get<any[]>(
      `${environment.apiUrl}/api/master/reports/all-sent-trxn-for-salesp-report/send-agent?G_Agent_ID=${agentId}&CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSentTransactionsForSalespersonByAgentBranch(agentId: any, branchId: any) {
    return this.http.get<any[]>(
      `${environment.apiUrl}/api/master/reports/all-sent-trxn-for-salesp-report/agent-branch?AgentID=${agentId}&Agent_Branch_ID=${branchId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getUserListForAgentBranch(agentBranchId: any) {
    return this.http.get<any[]>(
      `${environment.apiUrl}/api/master/reports/all-sent-trxn-for-salesp-report/user-list?AgentBranchId=${agentBranchId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDetailGrid(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/reports/all-sent-trxn-for-salesp-report/detail/grid`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDetailSummary(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/reports/all-sent-trxn-for-salesp-report/summary/grid`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
