import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root'
})
export class TreasureReportService {
  private baseUrl = environment.apiUrl;

  constructor(private http: HttpClient) {}



  getTreasuryReportList( customerType: string, fromDate: string): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: getCacheData('admin_token'),
      Accept: 'application/json',
      username: getCacheData('username'),
    });
    return this.http.get(
      `${this.baseUrl}/api/master/reports/treasury-report-list?FromDate=${fromDate}&ddlCustType=${customerType}`,
      { headers: headers }
    );
  }
}
