import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class TurnOverReportService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getCountries() {
    const headers = new HttpHeaders({
      Authorization: getCacheData('admin_token'),
      Accept: 'application/json',
      username: getCacheData('username'),
    });

    return this.http.get(`${this.url}/api/master/reports/get-country-wise-summary-report/country`, { headers });
  }

  getCountryWiseSummaryReport(SendingCountry: any, fromDate: any, toDate: any) {
    const headers = new HttpHeaders({
      Authorization: getCacheData('admin_token'),
      Accept: 'application/json',
      username: getCacheData('username'),
    });

    return this.http.get(
      `${this.url}/api/master/reports/get-country-wise-summary-report/grid`,
      {
        params: {
          SendingCountry: SendingCountry,
          StartDate: fromDate,
          EndDate: toDate,
        },
        headers: headers,
      }
    );
  }
}
